﻿namespace anbs_cp
{
    /// <summary>
    /// Форматирует число элементов в понятную строку
    /// </summary>
    public class CountFormatter : IValueFormatter
    {
        #region Cвойства класса
        /// <summary>
        /// Имена чисел (тысяч, миллионов, миллиардов и т.п.)
        /// </summary>
        public string[] CountNames { get; set; } = { "", "тыс.", "млн.", "млрд." };
        /// <summary>
        /// Знаков после запятой
        /// </summary>
        public byte DecimalPlaces { get; set; } = 1;
        /// <summary>
        /// Делители чисел
        /// </summary>
        public long[] Delimeters { get; set; } = { 1000, 1000000, 1000000000 };
        #endregion

        #region Реализация интерфейса
        /// <summary>
        /// Реализация интерфейса
        /// </summary>
        public string[] ValueNames { get => CountNames; set => CountNames = value; }
        /// <summary>
        /// Реализация интерфейса
        /// </summary>
        public long[] MaxSizes { get => Delimeters; set => Delimeters = value; }
        #endregion
    }
}