﻿using System.Collections.Generic;
namespace anbs_cp
{
    /// <summary>
    /// Класс, добавляющий реализацию некоторых методов Delphi, которые упрощают работу в C#.
    /// </summary>
    public static class LikeDelphi
    {
        /// <summary>
        /// Аналог функции IncludeTrailingBackslash
        /// </summary>
        /// <param name="path">Путь, к которому нужно добавить slash</param>
        /// <returns>Путь со slash в конце</returns>
        public static string IncludeTrailingBackslash(string path)
        {
            string result = path;
            int Index = path.Length - 1;
            if (path[Index] != '\\')
            {
                result = $"{path}\\";
            }
            return result;
        }
        /// <summary>
        /// Парсер строки в множество строк
        /// </summary>
        /// <param name="astring">Строка, которую нужно разбить</param>
        /// <param name="delim">Символ-делитель строки</param>
        /// <returns>Массив строк</returns>
        public static List<string> ParseString(string astring, char delim)
        {
            int from = -1;
            int to;
            List<string> result = new();
            do
            {
                from++;
                to = astring.IndexOf(delim, from);
                if (to <= 0)
                    to = astring.Length;
                if (from != to)
                    result.Add(astring[from..(to-from)]);
                from = to;
            } while (to != astring.Length);
            return result;
        }
    }
}